namespace FBX
{
    public class NodeModel : FBXNode
    {
        public NodeModel(string token) : base(token) {}

        public NodeTransform Transform
        {
            get { return (NodeTransform)Childs.Find(a => a.Attributes[0].ToString() == "\"Transform\""); }
        }

        public void RemoveTransform()
        {
            Childs.Remove(Transform);
        }

        public  void SetTransform(KeyframeSequence sequence)
        {
            if (sequence.KeyCount == 0)
                RemoveTransform();
            else
            {
                //jedyn istotn modyfikacj jest obrt
                Transform.R.SetModification('R',sequence);
            }
        }
    }
}