namespace FBX
{
    /// <summary>
    /// Translation, Rotation, Scale
    /// </summary>
    public class NodeModification : FBXNode
    {
        public NodeModification(string token) : base(token) {}

        public NodeXYZ X
        {
            get { return (NodeXYZ)Childs.Find(a => a.Attributes[0].ToString() == ("\"X\"")); }
        }
        public NodeXYZ Y
        {
            get { return (NodeXYZ)Childs.Find(a => a.Attributes[0].ToString() == ("\"Y\"")); }
        }
        public NodeXYZ Z
        {
            get { return (NodeXYZ)Childs.Find(a => a.Attributes[0].ToString() == ("\"Z\"")); }
        }

        internal void SetModification(char typModyfikacji, KeyframeSequence sequence)
        {
                X.SetKey(typModyfikacji, 'X', sequence);
                Y.SetKey(typModyfikacji, 'Y', sequence);
                Z.SetKey(typModyfikacji, 'Z', sequence);
        }
    }
}