﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    public class _MS_Connection
    {
        public static _MicroScribe myMicroScribe;

        internal bool StartMS(IntPtr intPtr)
        {
            myMicroScribe = new _MicroScribe(intPtr);

            if (!myMicroScribe.isConnected)    //czy udalo sie połaczyc z urzadzeniem
                return false;

            return true;
        }

        internal Point GetPosition2D()
        {
            Vector3 tipPos = GetPosition3D();

            //(_Mouse.X - 640) / 970.0F, (400 - _Mouse.Y) / 970.0F
            return new Point((int)(tipPos.X * 64) + 1280, 1024 - (int)(tipPos.Z * 31));

        }
        
        internal Vector3 GetPosition3D()
        {
            Vector3 tipPos = myMicroScribe.GetTipPosition();

            tipPos *=  50;
            tipPos = new Vector3(-tipPos.X, tipPos.Z, tipPos.Y);

            return tipPos;
        }

        internal Vector3 GetRotation3D()
        {
            Vector3 tipRot = myMicroScribe.GetTipOrientation();
            //tipRot = new Vector3(-tipRot.X, tipRot.Z, tipRot.Y);

            tipRot = new Vector3(-tipRot.X, -tipRot.Z, -tipRot.Y);


//TODO: sprawdzic czy jako katy czy radiany
            return tipRot;
        }


        internal bool GetLeftButton()
        {
            return myMicroScribe.IsButtonLeft();
        }

        internal bool GetRightButton()
        {
            return myMicroScribe.IsButtonRight();
        }
    }
}
