﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Rotplucs.Input;

namespace Rotplucs
{
    static class Hit
    {
        static PolyShape pS;

        //TODO:
        //Zaawansowane rzezbienie - pusza ray z wierzcholka piramidy, wzdluz krawedzi
        //po natrafiniu na trojkat zanim dojdzie do podstawy,
        //to zmienia punkt podsatyw poczatkowo, a pozniej
        //traktuje go jako plasczyzne tnaca.

        static Dictionary<int, Wielokat> WielokatyBoczne;
        static Dictionary<int, Wielokat> KrawedzieZle;
        static List<int> trojkatyDoUsuniecia;

        public static void HitSurface(PolyShape polyShape, Vector3 from, Vector3 to)
        {
            int nowy, nowy1, nowy2, nowy3, nowy4;

            pS = polyShape;

            //from = MyInput.Get3DPos();
            //pozycja kamery, aktualna
            //get3dPos zwraca mi pozycję kamery!
            //wektor kierunkowy - wyznaczone na podstawie tan() z odchylenia kursora od środka ekranu
            //Rotacja kamery obrócona dodatkowo o to powyższe
            //to = mousePosition3D - MyInput.Get3DRot() * 100000;


            Vector3 normalna = MyInput.Get3DRot();
            int kat = MyInput.ConeAngle;

        //rozwiązanie z uderzeniem "dłuta" w trójkąt i tylko wtedy wyznaczanie cięcia
            //RayTracedTriangle r = RayTrace.First(from, to, pS);
            //if (r != null)
            {

                //Vector3 p = r.PunktPrzeciecia;
                //int moc = (int)(Constants.ConeHeight - (p - MyInput.Get3DPos()).Length());
                //if (moc < 0)
                //    return;

            //drugi sposób, tnący tak jak stożek i nei przejmuej się niczym
                Vector3 p = to;
                int moc = Constants.ConeHeight;



                Vector3[] piramidka = Geometry.CreateCone(p, normalna, kat, moc);
                
                nowy = Geometry.AddVertax(piramidka[4]);
                nowy1 = Geometry.AddVertax(piramidka[0]);
                nowy2 = Geometry.AddVertax(piramidka[1]);
                nowy3 = Geometry.AddVertax(piramidka[2]);
                nowy4 = Geometry.AddVertax(piramidka[3]);


                //musi byc na pewno przed usuinieciem trójkąta, ale cośjeszze jest źle
                Ray ray1 = RayTrace.Trace(pS.VerticesPos(nowy), pS.VerticesPos(nowy1), nowy, pS);
                Ray ray2 = RayTrace.Trace(pS.VerticesPos(nowy), pS.VerticesPos(nowy2), nowy, pS);
                Ray ray3 = RayTrace.Trace(pS.VerticesPos(nowy), pS.VerticesPos(nowy3), nowy, pS);
                Ray ray4 = RayTrace.Trace(pS.VerticesPos(nowy), pS.VerticesPos(nowy4), nowy, pS);


                //raytace lecąc tworzy krawędzie, wie kiedy jest wewnątrz bryły, a kiedy poza nią.

                WielokatyBoczne = new Dictionary<int, Wielokat>();
                trojkatyDoUsuniecia = new List<int>();
                KrawedzieZle = new Dictionary<int, Wielokat>();

                List<int> wierzcholkiDoUsuniecia = new List<int>();
                
                
                //stworz plaszczyzne z trojkata
                List<Wielokat> wielokatyPiramidy = new List<Wielokat>();
                wielokatyPiramidy.Add(ZrobCosWaznego(nowy, nowy1, nowy3, ray1, ray3));
                wielokatyPiramidy.Add(ZrobCosWaznego(nowy, nowy3, nowy2, ray3, ray2));
                wielokatyPiramidy.Add(ZrobCosWaznego(nowy, nowy2, nowy4, ray2, ray4));
                wielokatyPiramidy.Add(ZrobCosWaznego(nowy, nowy4, nowy1, ray4, ray1));

                //usuwanie trojkatow, bo sa trojkaty, ktorych wszystkie wierzcholki są poza, a i tak je trzeba usunac.
                trojkatyDoUsuniecia.Sort((x, y) => y.CompareTo(x)); //sortBackward
                foreach (var t in trojkatyDoUsuniecia)
                {
                    Geometry.RemoveTriagle(t);
                }

                //jeszcze trzeba usunac wiercholki ktore sa w piramiedzie, w sesnie cały trójkąt jak jest w piramidzie to trzeba go usunąć
                for (int vertex = 0; vertex < pS.verticesCount(); vertex++)
                {
                    //sprawdz po ktorej stronie plaszczyzny jest wierzcholek
                    float odleglosc1 = Geometry.OdlegloscPktDoPla(pS.VerticesPos(vertex),
                        new Plaszczyzna(pS.VerticesPos(nowy), pS.VerticesPos(nowy1),pS.VerticesPos(nowy3), p));
                    float odleglosc2 = Geometry.OdlegloscPktDoPla(pS.VerticesPos(vertex),
                        new Plaszczyzna(pS.VerticesPos(nowy), pS.VerticesPos(nowy3),pS.VerticesPos(nowy2), p));
                    float odleglosc3 = Geometry.OdlegloscPktDoPla(pS.VerticesPos(vertex),
                        new Plaszczyzna(pS.VerticesPos(nowy), pS.VerticesPos(nowy2),pS.VerticesPos(nowy4), p));
                    float odleglosc4 = Geometry.OdlegloscPktDoPla(pS.VerticesPos(vertex),
                        new Plaszczyzna(pS.VerticesPos(nowy), pS.VerticesPos(nowy4),pS.VerticesPos(nowy1), p));
                    if ((odleglosc1 > 0) &&  (odleglosc2 > 0) &&  (odleglosc3 > 0) &&  (odleglosc4 > 0))
                        wierzcholkiDoUsuniecia.Add(vertex);
                }


                //wyrzuc złe krawedzie
                //krawedz zla to taka co zostala przecieta!, bo wczesniej mogla przyapadkiem zostac dodana
                /*foreach (var w in wielokatyPiramidy)
                {
                    foreach (var zle in KrawedzieZle)
                    {
                        foreach (var k in zle.Value.Krawedzie)
                        {
                            Krawedz zla = w.Krawedzie.Find(x => (x.P1 == k.P1 && x.P2 == k.P2) || (x.P1 == k.P2 && x.P2 == k.P1));
                            if (zla != null)
                                w.Krawedzie.Remove(zla);
                        }
                        //Geometry.CreatePolygons(w.Value, w.Key, pS);
                    }
                }*/

                foreach (var w in WielokatyBoczne)
                {
                    foreach (var k in KrawedzieZle[w.Key].Krawedzie)
                    {
                        Krawedz zla = w.Value.Krawedzie.Find(x => (x.P1 == k.P1 && x.P2 == k.P2));
                        if (zla != null)
                            w.Value.Krawedzie.Remove(zla);
                    }
                    //Geometry.CreatePolygons(w.Value, w.Key, pS);
                }

                foreach (var v in wierzcholkiDoUsuniecia)
                {
                    Geometry.RemoveVertax(v);
                }

                Polygons.CreateAll(wielokatyPiramidy, WielokatyBoczne,pS);

                //tworzy stozek
                //Geometry.AddTriangle(nowy1, nowy3, nowy);
                //Geometry.AddTriangle(nowy3, nowy2, nowy);
                //Geometry.AddTriangle(nowy2, nowy4, nowy);
                //Geometry.AddTriangle(nowy4, nowy1, nowy);

                
                //Dla każdego trójkąta, przeszukać wszystkie Reje, w poszukiwaniu tego trójkat i jego przecieć, 
                //tworzymy dzięki temu te poprzeczne wielokąty.
            }
        }

        private static Wielokat ZrobCosWaznego(int nowy, int nowyA, int nowyB, Ray rayA, Ray rayB)
        {
            Wielokat wielokat = new Wielokat(new Plaszczyzna(Geometry.Normalna(nowy, nowyA, nowyB), pS.VerticesPos(nowy)));
            wielokat.Krawedzie = CreateAllPoints(new Trojkat(nowy,
                 Geometry.AddVertax(pS.VerticesPos(nowy) + (pS.VerticesPos(nowyA) - pS.VerticesPos(nowy)) * 10000),
                 Geometry.AddVertax(pS.VerticesPos(nowy) + (pS.VerticesPos(nowyB) - pS.VerticesPos(nowy)) * 10000)),
                 rayA, rayB);

            return wielokat;
        }

        static List<PunktNaKrawedzi> PodzieloneKrawedzie;
        private static int ZnajdzPunktNaKrawedzi(int p1, int p2, bool visibility, Trojkat t)
        {
            int punkt;
            PunktNaKrawedzi pnk1 = PodzieloneKrawedzie.Find(x => (x.V1 == p1 && x.V2 == p2) || (x.V1 == p2 && x.V2 == p1));
            if (pnk1 == null)
            {
                Vector3 punkt1 = Geometry.WhereLineIntersectTriangle(pS.VerticesPos(p1), pS.VerticesPos(p2), t);

                //jesli są w inne strony to znaczy, ze jest pomiedzy nimi ;D ha!
                //a jeśli w te same to nie leży na odcinku
                if(Geometry.SameSide(punkt1 - pS.VerticesPos(p1), punkt1 - pS.VerticesPos(p2)))
                    punkt1 = Vector3.Zero;


                if (punkt1 != Vector3.Zero)
                {
                    if (visibility)
                    {
                        punkt = Geometry.AddVertax(punkt1);
                    }
                    else
                        punkt = pS.GetNewVirtualVeraxNumber();
                    PodzieloneKrawedzie.Add(new PunktNaKrawedzi(p1, p2, punkt));
                }
                else
                    punkt = -1;
            }
            else
                punkt = pnk1.Point;

            return punkt;
        }
        static List<Krawedz> krawedzieBoczne;
        static List<Krawedz> krawedzieUciete;

        //znajdOdcinekPRzecieciaDwochTrojkatow
        private static List<Krawedz> CreateAllPoints(Trojkat trojkat, Ray rayA, Ray rayB)
        {
            PodzieloneKrawedzie = new List<PunktNaKrawedzi>();
            List<Krawedz> krawedzie = new List<Krawedz>();

            for (int i = 0; i < pS.indicesCount(); i += 3)
            {
                krawedzieBoczne = new List<Krawedz>();
                krawedzieUciete = new List<Krawedz>();
                bool isKrawedz = false;
                Krawedz K = new Krawedz(-1, -1);

                int p0 = pS.Triangles(i);
                int p1 = pS.Triangles(i + 1);
                int p2 = pS.Triangles(i + 2);

                List<int> vertexy = new List<int>();

                DodajOdpowiedneiKrawedzie(p0, p1, trojkat, ref vertexy);
                DodajOdpowiedneiKrawedzie(p1, p2, trojkat, ref vertexy);
                DodajOdpowiedneiKrawedzie(p2, p0, trojkat, ref vertexy);

                if (vertexy.Count == 2)     //krawedz nowa
                {
                    isKrawedz = true;
                    K = new Krawedz(vertexy[0], vertexy[1]);
                }
                else if (vertexy.Count == 1)
                {
//GLUPI POYSL z -1 ;p bo byl problem z wirtualnymi wierzchołkami
                    int v = -1;
                    isKrawedz = true;

                    if (rayA != null && rayA.PunktyNaTrojkatach.ContainsKey(i))
                        v = rayA.PunktyNaTrojkatach[i];
                    else if (rayB != null && rayB.PunktyNaTrojkatach.ContainsKey(i))
                        v = rayB.PunktyNaTrojkatach[i];
                    else
                        isKrawedz = false;
                    K = new Krawedz(vertexy[0], v);
                }
                else //RAY wie jaki trojkat przeciąl, jeśli oba przecieły ten sam to łączymy!!
                {
                    int v1 = -1;
                    int v2 = -1;
                    if (rayA != null && rayA.PunktyNaTrojkatach.ContainsKey(i))
                        v1 = rayA.PunktyNaTrojkatach[i];
                    if (rayB != null && rayB.PunktyNaTrojkatach.ContainsKey(i))
                        v2 = rayB.PunktyNaTrojkatach[i];

                    if (v2 >= 0 && v2 >= 0)
                        isKrawedz = true;
                    K = new Krawedz(v1, v2);
                }

                if (isKrawedz)
                {
                    //każda Krawedź ma dwa końce (2 trójkąty których dotyka)
                    krawedzie.Add(K);
                    int poly = pS.getPolyNumberFromTriangle(i);
                    {
                        if (!WielokatyBoczne.ContainsKey(poly))
                        {
                            WielokatyBoczne[poly] = new Wielokat(new Plaszczyzna(Geometry.Normalna(p0, p1, p2), pS.VerticesPos(p0)));
                            KrawedzieZle[poly] = new Wielokat(new Plaszczyzna(Geometry.Normalna(p0, p1, p2), pS.VerticesPos(p0)));
                        }
                        WielokatyBoczne[poly].Krawedzie.Add(K);

                        foreach (var k in krawedzieBoczne)
                        {
                            if (!WielokatyBoczne[poly].Krawedzie.Exists(x => (x.P1 == k.P1 && x.P2 == k.P2)))
                                WielokatyBoczne[poly].Krawedzie.Add(k);
                        }
                        //WielokatyBoczne[poly].Krawedzie.AddRange(krawedzieBoczne);

                        foreach (var k in krawedzieUciete)
                        {
                            if (!KrawedzieZle[poly].Krawedzie.Exists(x => (x.P1 == k.P1 && x.P2 == k.P2)))
                                KrawedzieZle[poly].Krawedzie.Add(k);
                        }
                    }

                    if (!trojkatyDoUsuniecia.Exists(x => x == i))
                        trojkatyDoUsuniecia.Add(i);

                    //dodaaj krawędź to wielokatów bocznych w taki sposób - tak jak w Cut
                    //potem stworz wielokaty boczne dla trójkąta I
                }
            }

            if (rayA != null)
                krawedzie.AddRange(rayA.Krawedzie);

            if (rayB != null)
                krawedzie.AddRange(rayB.Krawedzie);

            return krawedzie;
        }

        private static void DodajOdpowiedneiKrawedzie(int pA, int pB, Trojkat trojkat, ref List<int> vertices)
        {
            bool visible = pS.IsVisibleEdge(pA, pB);

            int punkt = ZnajdzPunktNaKrawedzi(pA, pB, visible, trojkat);    //sprawdza czy już był lub szuka nowego
            if (punkt != -1)
            {
                vertices.Add(punkt);
                if (Geometry.SameSide(trojkat.Normalna(), pS.VerticesPos(trojkat.P1) - pS.VerticesPos(pA)))
                    NowaKrawedz(pB, punkt, visible);
                else
                    NowaKrawedz(pA, punkt, visible);

                krawedzieUciete.Add(new Krawedz(pA, pB));
            }
            else
                krawedzieBoczne.Add(new Krawedz(pA, pB));
        }

        private static void NowaKrawedz(int p1, int p2, bool visible)
        {
            if (visible)
                krawedzieBoczne.Add(new Krawedz(p1, p2));
            else
                pS.AddInvisible(p1, p2);
        }
    }
}
