﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;

namespace Rotplucs.Input
{
    static class OtherInput
    {
        static Vector3 firstClick;
        static Vector3 secondClick;
        public static Vector3 Camera;

        static bool leftButton = false;
        static bool rightButton = false;
        static bool cofnij = false;
        static bool powtorz = false;

        public static void Update(PolyShape PS)
        {
            //Press Esc To Exit
            if (MyInput.IsCofnijEdycje())
            {
                if (!cofnij)
                {
                    cofnij = true;
                    PS.CofnijEdycje();
                }
            }
            else
                cofnij = false;

            if (MyInput.IsPowtorzEdycje())
            {
                if (!powtorz)
                {
                    powtorz = true;
                    PS.PowtorzEdycje();
                }
            }
            else
                powtorz = false;


            MouseCursor.Update(MyInput.GetCursorPos());

            Vector3 mousePosition3D = MyInput.Get3DPos();

            Camera = mousePosition3D - MyInput.Get3DRot() * 100000;

            if (MyInput.IsCutingStart())
            {
                if (!leftButton)
                {
                    firstClick = mousePosition3D;
                    leftButton = true;
                    LineMove.NewLine();
                }
                LineMove.AddPoint(mousePosition3D);
                if (LineMove.Count % 20 == 0)
                {
                    secondClick = mousePosition3D;
                    PS.CutSurface(firstClick, secondClick, Camera);

                    firstClick = secondClick;
                }
            }
            else
            {
                if (leftButton)
                {
                    secondClick = mousePosition3D;

                    PS.CutSurface(firstClick, secondClick, Camera);
                    leftButton = false;
                }
            }

            if (MyInput.IsHitingStart())
            {
                if (!rightButton)
                    rightButton = true;
            }
            else
            {
                if (rightButton)
                {
                    PS.HitSurface(Camera, mousePosition3D);
                    /*if (MyInput._MS != null)
                        PS.HitSurface(mousePosition3D - MyInput.Get3DRot() * 100000, mousePosition3D);
                    else
                    {
                        Vector3 pozycjaKamery = Camera;
                        pozycjaKamery *= 10000;
                        PS.HitSurface(pozycjaKamery, mousePosition3D);
                    }*/
                    rightButton = false;
                }
            }

            if (MyInput.IsZapisRzezbe())
            {
                PS.Save();
            }

            if (MyInput.IsOdczytRzezbe())
            {
                PS.Open();
            }

            if (MyInput.IsNewPolyShape())
            {
                PS.LoadCube();
            }
        }
    }
}
