﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    static class MouseCursor
    {
        static SpriteBatch _spriteBatch;
        static Vector2 _mousePos;
        static Texture2D _mouseTexture;

        public static void Load(Texture2D texture2D, GraphicsDevice graphicsDevice)
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            _spriteBatch = new SpriteBatch(graphicsDevice);  
              _mousePos = Vector2.Zero;
            // load the image
              _mouseTexture = texture2D;
        }

        public static void Draw()
        {
            _spriteBatch.Begin();
            _spriteBatch.Draw(_mouseTexture, _mousePos, null, Color.White, 0f,
                    Vector2.Zero, 1.0f, SpriteEffects.None, 0f);
            _spriteBatch.End();
        }

        public static void Update(Point p)
        {
            _mousePos.X = p.X;
            _mousePos.Y = p.Y;
        }

    }
}
