namespace FBX
{
    public class NodeXYZ : FBXNode
    {
        public NodeXYZ(string token) : base(token) {}

        public int KeyCount
        {
            set { Childs.Find(a => a.Name == "KeyCount").Attributes[0] = new StringNode(value); }
        }

        public double Default
        {
            set { Childs.Find(a => a.Name == "Default").Attributes[0] = new StringNode(value); }
        }

        internal void SetKey(char co, char os, KeyframeSequence key)
        {
            Default = key.Default(co, Name[1]); //od 1 bo postaci "X" wiec omijamy znak "
            KeyCount = key.KeyCount;
            FBXNode node = Childs.Find(a => a.Name == "Key");
            node.Attributes.Clear();
            foreach (KeyframeNode k in key.Keyframes)
            {
                node.Attributes.Add(new StringNode(k.ToString(co, os)));
            }
        }
    }
}