﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Rotplucs
{
    public static class Constants
    {
        //XNA cordiantes
        //   y ^ 
        //     |
        //     |
        //     |
        //     O----->
        //    /       x
        //   /
        //  v z


        //MicroScribe cordiantes
        //   z ^ 
        //     |
        //     |
        // x   |
        //<----O
        //    /
        //   /
        //  V y


        public static Vector3 StartingCameraPos = new Vector3(-500, 400, 2000);
        public static Vector3 PolyShapeSize = new Vector3(400, 340, 200);
        public static Vector3 PolyShapePos = new Vector3(0, 0, 0);//new Vector3(-600, 400, 0); - dla Microscriba
        public static Point WindowResolution = new Point(1280, 0);  //drugi parametr ustawi się automatycznie na podstawie AspectRatio monitora
        public static Point WindowSize;

        public static int ConeHeight = 1000;
    }
}
