﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Rotplucs
{
    static class TextOnScreen
    {
        private static SpriteFont _font;
        private static Vector2 _fontPos = new Vector2(10, 10);
        private static Vector2 _fontPos2 = new Vector2(350, 10);
        private static Vector2 _fontPos3 = new Vector2(750, 10);

        private static Vector2 _fontPos_2 = new Vector2(10, 200);
        private static Vector2 _fontPos2_2 = new Vector2(350, 200);
        private static Vector2 _fontPos3_2 = new Vector2(750, 200);
        private static SpriteBatch _spriteBatch;
        private static GraphicsDevice _gd;
        private static Texture2D _texture;

        public static void Load(SpriteFont fontName, GraphicsDevice graphicsDevice)
        {
            _font = fontName;
            _gd = graphicsDevice;
            _spriteBatch = new SpriteBatch(_gd);
        }

        public static void Load(SpriteFont fontName, Texture2D loadTexture, GraphicsDevice graphicsDevice)
        {
            _texture = loadTexture;
            _font = fontName;
            _gd = graphicsDevice;
            _spriteBatch = new SpriteBatch(_gd);
        }
        
        public static void Draw(int trojkaty, int wierzcholki, int wielokaty)
        {
            _spriteBatch.Begin();
            _spriteBatch.DrawString(_font, "Trojkatow: " + trojkaty, _fontPos, Color.White);
            _spriteBatch.DrawString(_font, "Wierzcholkow: " + wierzcholki, _fontPos2, Color.White);
            _spriteBatch.DrawString(_font, "Wielokatow: " + wielokaty, _fontPos3, Color.White);
            _spriteBatch.End();
        }


        public static void DrawDebug()
        {
            _spriteBatch.Begin();
            //_spriteBatch.DrawString(_font, "Rozmiar: " + GUI.getScrollValue(), _fontPos_2, Color.White);
            //_spriteBatch.DrawString(_font, "Y: " + orient.Y, _fontPos2_2, Color.Green);
            //_spriteBatch.DrawString(_font, "Z: " + orient.Z, _fontPos3_2, Color.Green);
            _spriteBatch.End();
        }



        public static void DrawWindow(string nazwa)
        {
            _spriteBatch.Begin();
            _spriteBatch.Draw(_texture, new Vector2(300, 200), new Color(128, 128, 128));
            _spriteBatch.DrawString(_font, "Nazwa:\n " + nazwa, new Vector2(350, 250), Color.Black);
            _spriteBatch.End();
        }

        //sprite jako nazwa i wartość, jak nazwa już była to na liscie sprawdzamy jej pozycję, to dla Debug
    }
}
